/*

InstructionSet

Copyright (c) 2017 KINOSHITA Hidetoshi

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is furnished
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

--------------------------------------------------------------------------

InstructionSet

Copyright (c) 2017 ؉pr

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\t
gEFAvj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐Ɉ
Ƃ𖳏ŋ܂Bɂ́A\tgEFA̕gpAʁAύXA
AfځAЕzATuCZXAс^܂͔̔錠Aу\tgEF
A񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dv
ɋLڂ̂Ƃ܂B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕
؂Ȃ񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KA
ьNQɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂
B҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\
tgEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈
ɂĐ؂̐AQȂ̋`ɂĉ̐ӔCȂ
̂Ƃ܂B

*/

//
// _cpuid ɂ SIMDT|[g󋵊mF
//
// Refferences:
//   https://msdn.microsoft.com/ja-jp/library/hskdteyh.aspx
//

#pragma once

//#include <intrin.h>  
#include <array>
#include <bitset>
#include <vector>


namespace hide {

class InstructionSet
{
	// forward declarations  
	//class InstructionSet_Internal;

public:
	// getters  
	static std::string Vendor(void);
	static std::string Brand(void);

	static bool SSE3(void);
	static bool PCLMULQDQ(void);
	static bool MONITOR(void);
	static bool SSSE3(void);
	static bool FMA(void);
	static bool CMPXCHG16B(void);
	static bool SSE41(void);
	static bool SSE42(void);
	static bool MOVBE(void);
	static bool POPCNT(void);
	static bool AES(void);
	static bool XSAVE(void);
	static bool OSXSAVE(void);
	static bool AVX(void);
	static bool F16C(void);
	static bool RDRAND(void);

	static bool MSR(void);
	static bool CX8(void);
	static bool SEP(void);
	static bool CMOV(void);
	static bool CLFSH(void);
	static bool MMX(void);
	static bool FXSR(void);
	static bool SSE(void);
	static bool SSE2(void);

	static bool FSGSBASE(void);
	static bool BMI1(void);
	static bool HLE(void);
	static bool AVX2(void);
	static bool BMI2(void);
	static bool ERMS(void);
	static bool INVPCID(void);
	static bool RTM(void);
	static bool AVX512F(void);
	static bool RDSEED(void);
	static bool ADX(void);
	static bool AVX512PF(void);
	static bool AVX512ER(void);
	static bool AVX512CD(void);
	static bool SHA(void);

	static bool PREFETCHWT1(void);

	static bool LAHF(void);
	static bool LZCNT(void);
	static bool ABM(void);
	static bool SSE4a(void);
	static bool XOP(void);
	static bool TBM(void);
	
	static bool SYSCALL(void);
	static bool MMXEXT(void);
	static bool RDTSCP(void);
	static bool _3DNOWEXT(void);
	static bool _3DNOW(void);
	
private:
	class InstructionSet_Internal
	{
	public:
		InstructionSet_Internal();			// Ctor

		int nIds_;
		int nExIds_;
		std::string vendor_;
		std::string brand_;
		bool isIntel_;
		bool isAMD_;
		std::bitset<32> f_1_ECX_;
		std::bitset<32> f_1_EDX_;
		std::bitset<32> f_7_EBX_;
		std::bitset<32> f_7_ECX_;
		std::bitset<32> f_81_ECX_;
		std::bitset<32> f_81_EDX_;
		std::vector<std::array<int, 4>> data_;
		std::vector<std::array<int, 4>> extdata_;
	};

	static const InstructionSet_Internal CPU_Rep;
};

}
